Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/LDF/ldfc1d_c2d.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/LDF/ldfc1d_c2d.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/LDF/ldfc1d_c2d.F90	(revision 10986)
@@ -61,6 +61,9 @@
       !!----------------------------------------------------------------------
       !
-      IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) '   ldf_c1d : set a given profile to eddy mixing coefficients'
+      IF(lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) '   ldf_c1d : set a given profile to eddy mixing coefficients'
+         IF(lflush) CALL FLUSH(numout)
+      ENDIF
       !
       ! initialization of the profile
@@ -134,6 +137,9 @@
       !!----------------------------------------------------------------------
       !
-      IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) '   ldf_c2d :   aht = Ufac * max(e1,e2)   with Ufac = ', pUfac, ' m/s'
+      IF(lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) '   ldf_c2d :   aht = Ufac * max(e1,e2)   with Ufac = ', pUfac, ' m/s'
+         IF(lflush) CALL FLUSH(numout)
+      ENDIF
       !
       !
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/LDF/ldfdyn.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/LDF/ldfdyn.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/LDF/ldfdyn.F90	(revision 10986)
@@ -151,4 +151,5 @@
          WRITE(numout,*) '            lower limit (default 1.0)         rn_minfac    = ', rn_minfac
          WRITE(numout,*) '            upper limit (default 1.0)         rn_maxfac    = ', rn_maxfac
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
 
@@ -224,4 +225,5 @@
          END SELECT
          WRITE(numout,*)
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       
@@ -233,5 +235,8 @@
       !
       IF( ln_dynldf_OFF ) THEN
-         IF(lwp) WRITE(numout,*) '   ==>>>   No viscous operator selected. ahmt and ahmf are not allocated'
+         IF(lwp) THEN
+            WRITE(numout,*) '   ==>>>   No viscous operator selected. ahmt and ahmf are not allocated'
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
          RETURN
          !
@@ -255,11 +260,17 @@
          !
          CASE(   0  )      !==  constant  ==!
-            IF(lwp) WRITE(numout,*) '   ==>>>   eddy viscosity. = constant = ', zah0, cl_Units
+            IF(lwp) THEN
+               WRITE(numout,*) '   ==>>>   eddy viscosity. = constant = ', zah0, cl_Units
+               IF(lflush) CALL FLUSH(numout)
+            ENDIF
             ahmt(:,:,1:jpkm1) = zah0
             ahmf(:,:,1:jpkm1) = zah0
             !
          CASE(  10  )      !==  fixed profile  ==!
-            IF(lwp) WRITE(numout,*) '   ==>>>   eddy viscosity = F( depth )'
-            IF(lwp) WRITE(numout,*) '           surface viscous coef. = constant = ', zah0, cl_Units
+            IF(lwp) THEN
+               WRITE(numout,*) '   ==>>>   eddy viscosity = F( depth )'
+               WRITE(numout,*) '           surface viscous coef. = constant = ', zah0, cl_Units
+               IF(lflush) CALL FLUSH(numout)
+            ENDIF
             ahmt(:,:,1) = zah0                        ! constant surface value
             ahmf(:,:,1) = zah0
@@ -267,5 +278,8 @@
             !
          CASE ( -20 )      !== fixed horizontal shape read in file  ==!
-            IF(lwp) WRITE(numout,*) '   ==>>>   eddy viscosity = F(i,j) read in eddy_viscosity.nc file'
+            IF(lwp) THEN
+               WRITE(numout,*) '   ==>>>   eddy viscosity = F(i,j) read in eddy_viscosity.nc file'
+               IF(lflush) CALL FLUSH(numout)
+            ENDIF
             CALL iom_open( 'eddy_viscosity_2D.nc', inum )
             CALL iom_get ( inum, jpdom_data, 'ahmt_2d', ahmt(:,:,1) )
@@ -278,11 +292,17 @@
             !
          CASE(  20  )      !== fixed horizontal shape  ==!
-            IF(lwp) WRITE(numout,*) '   ==>>>   eddy viscosity = F( e1, e2 ) or F( e1^3, e2^3 ) (lap. or blp. case)'
-            IF(lwp) WRITE(numout,*) '           using a fixed viscous velocity = ', rn_Uv  ,' m/s   and   Lv = Max(e1,e2)'
-            IF(lwp) WRITE(numout,*) '           maximum reachable coefficient (at the Equator) = ', zah_max, cl_Units, '  for e1=1°)'
+            IF(lwp) THEN
+               WRITE(numout,*) '   ==>>>   eddy viscosity = F( e1, e2 ) or F( e1^3, e2^3 ) (lap. or blp. case)'
+               WRITE(numout,*) '           using a fixed viscous velocity = ', rn_Uv  ,' m/s   and   Lv = Max(e1,e2)'
+               WRITE(numout,*) '           maximum reachable coefficient (at the Equator) = ', zah_max, cl_Units, '  for e1=1°)'
+               IF(lflush) CALL FLUSH(numout)
+            ENDIF
             CALL ldf_c2d( 'DYN', zUfac      , inn        , ahmt, ahmf )         ! surface value proportional to scale factor^inn
             !
          CASE( -30  )      !== fixed 3D shape read in file  ==!
-            IF(lwp) WRITE(numout,*) '   ==>>>   eddy viscosity = F(i,j,k) read in eddy_viscosity_3D.nc file'
+            IF(lwp) THEN
+               WRITE(numout,*) '   ==>>>   eddy viscosity = F(i,j,k) read in eddy_viscosity_3D.nc file'
+               IF(lflush) CALL FLUSH(numout)
+            ENDIF
             CALL iom_open( 'eddy_viscosity_3D.nc', inum )
             CALL iom_get ( inum, jpdom_data, 'ahmt_3d', ahmt )
@@ -291,19 +311,28 @@
             !
          CASE(  30  )       !==  fixed 3D shape  ==!
-            IF(lwp) WRITE(numout,*) '   ==>>>   eddy viscosity = F( latitude, longitude, depth )'
-            IF(lwp) WRITE(numout,*) '           using a fixed viscous velocity = ', rn_Uv  ,' m/s   and   Ld = Max(e1,e2)'
-            IF(lwp) WRITE(numout,*) '           maximum reachable coefficient (at the Equator) = ', zah_max, cl_Units, '  for e1=1°)'
+            IF(lwp) THEN
+               WRITE(numout,*) '   ==>>>   eddy viscosity = F( latitude, longitude, depth )'
+               WRITE(numout,*) '           using a fixed viscous velocity = ', rn_Uv  ,' m/s   and   Ld = Max(e1,e2)'
+               WRITE(numout,*) '           maximum reachable coefficient (at the Equator) = ', zah_max, cl_Units, '  for e1=1°)'
+               IF(lflush) CALL FLUSH(numout)
+            ENDIF
             CALL ldf_c2d( 'DYN', zUfac      , inn        , ahmt, ahmf )         ! surface value proportional to scale factor^inn
             CALL ldf_c1d( 'DYN', ahmt(:,:,1), ahmf(:,:,1), ahmt, ahmf )  ! reduction with depth
             !
          CASE(  31  )       !==  time varying 3D field  ==!
-            IF(lwp) WRITE(numout,*) '   ==>>>   eddy viscosity = F( latitude, longitude, depth , time )'
-            IF(lwp) WRITE(numout,*) '           proportional to the local velocity : 1/2 |u|e (lap) or 1/12 |u|e^3 (blp)'
+            IF(lwp) THEN
+               WRITE(numout,*) '   ==>>>   eddy viscosity = F( latitude, longitude, depth , time )'
+               WRITE(numout,*) '           proportional to the local velocity : 1/2 |u|e (lap) or 1/12 |u|e^3 (blp)'
+               IF(lflush) CALL FLUSH(numout)
+            ENDIF
             !
             l_ldfdyn_time = .TRUE.     ! will be calculated by call to ldf_dyn routine in step.F90
             !
          CASE(  32  )       !==  time varying 3D field  ==!
-            IF(lwp) WRITE(numout,*) '   ==>>>   eddy viscosity = F( latitude, longitude, depth , time )'
-            IF(lwp) WRITE(numout,*) '           proportional to the local deformation rate and gridscale (Smagorinsky)'
+            IF(lwp) THEN
+               WRITE(numout,*) '   ==>>>   eddy viscosity = F( latitude, longitude, depth , time )'
+               WRITE(numout,*) '           proportional to the local deformation rate and gridscale (Smagorinsky)'
+               IF(lflush) CALL FLUSH(numout)
+            ENDIF
             !
             l_ldfdyn_time = .TRUE.     ! will be calculated by call to ldf_dyn routine in step.F90
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/LDF/ldfslp.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/LDF/ldfslp.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/LDF/ldfslp.F90	(revision 10986)
@@ -746,4 +746,5 @@
          WRITE(numout,*) 'ldf_slp_init : direction of lateral mixing'
          WRITE(numout,*) '~~~~~~~~~~~~'
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
@@ -752,5 +753,8 @@
       !
       IF( ln_traldf_triad ) THEN        ! Griffies operator : triad of slopes
-         IF(lwp) WRITE(numout,*) '   ==>>>   triad) operator (Griffies)'
+         IF(lwp) THEN
+            WRITE(numout,*) '   ==>>>   triad) operator (Griffies)'
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
          ALLOCATE( triadi_g(jpi,jpj,jpk,0:1,0:1) , triadj_g(jpi,jpj,jpk,0:1,0:1) ,     &
             &      triadi  (jpi,jpj,jpk,0:1,0:1) , triadj  (jpi,jpj,jpk,0:1,0:1) ,     &
@@ -760,5 +764,8 @@
          !
       ELSE                             ! Madec operator : slopes at u-, v-, and w-points
-         IF(lwp) WRITE(numout,*) '   ==>>>   iso operator (Madec)'
+         IF(lwp) THEN
+            WRITE(numout,*) '   ==>>>   iso operator (Madec)'
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
          ALLOCATE( omlmask(jpi,jpj,jpk) ,                                                                        &
             &      uslp(jpi,jpj,jpk) , uslpml(jpi,jpj) , wslpi(jpi,jpj,jpk) , wslpiml(jpi,jpj) ,     &
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/LDF/ldftra.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/LDF/ldftra.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/LDF/ldftra.F90	(revision 10986)
@@ -146,4 +146,5 @@
          WRITE(numout,*) 'ldf_tra_init : lateral tracer diffusion'
          WRITE(numout,*) '~~~~~~~~~~~~ '
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       
@@ -180,4 +181,5 @@
          WRITE(numout,*) '            lateral diffusive velocity (if cst)  rn_Ud           = ', rn_Ud, ' m/s'
          WRITE(numout,*) '            lateral diffusive length   (if cst)  rn_Ld           = ', rn_Ld, ' m'
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
@@ -271,4 +273,5 @@
          END SELECT
          WRITE(numout,*)
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
 
@@ -281,5 +284,8 @@
       IF( ln_traldf_OFF ) THEN               !== no explicit diffusive operator  ==!
          !
-         IF(lwp) WRITE(numout,*) '   ==>>>   No diffusive operator selected. ahtu and ahtv are not allocated'
+         IF(lwp) THEN
+            WRITE(numout,*) '   ==>>>   No diffusive operator selected. ahtu and ahtv are not allocated'
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
          RETURN
          !
@@ -304,11 +310,17 @@
          !
          CASE(   0  )      !==  constant  ==!
-            IF(lwp) WRITE(numout,*) '   ==>>>   eddy diffusivity = constant = ', aht0, cl_Units
+            IF(lwp) THEN
+               WRITE(numout,*) '   ==>>>   eddy diffusivity = constant = ', aht0, cl_Units
+               IF(lflush) CALL FLUSH(numout)
+            ENDIF
             ahtu(:,:,1:jpkm1) = aht0
             ahtv(:,:,1:jpkm1) = aht0
             !
          CASE(  10  )      !==  fixed profile  ==!
-            IF(lwp) WRITE(numout,*) '   ==>>>   eddy diffusivity = F( depth )'
-            IF(lwp) WRITE(numout,*) '           surface eddy diffusivity = constant = ', aht0, cl_Units
+            IF(lwp) THEN
+               WRITE(numout,*) '   ==>>>   eddy diffusivity = F( depth )'
+               WRITE(numout,*) '           surface eddy diffusivity = constant = ', aht0, cl_Units
+               IF(lflush) CALL FLUSH(numout)
+            ENDIF
             ahtu(:,:,1) = aht0                        ! constant surface value
             ahtv(:,:,1) = aht0
@@ -316,5 +328,8 @@
             !
          CASE ( -20 )      !== fixed horizontal shape and magnitude read in file  ==!
-            IF(lwp) WRITE(numout,*) '   ==>>>   eddy diffusivity = F(i,j) read in eddy_diffusivity.nc file'
+            IF(lwp) THEN
+               WRITE(numout,*) '   ==>>>   eddy diffusivity = F(i,j) read in eddy_diffusivity.nc file'
+               IF(lflush) CALL FLUSH(numout)
+            ENDIF
             CALL iom_open( 'eddy_diffusivity_2D.nc', inum )
             CALL iom_get ( inum, jpdom_data, 'ahtu_2D', ahtu(:,:,1) )
@@ -327,14 +342,20 @@
             !
          CASE(  20  )      !== fixed horizontal shape  ==!
-            IF(lwp) WRITE(numout,*) '   ==>>>   eddy diffusivity = F( e1, e2 ) or F( e1^3, e2^3 ) (lap or blp case)'
-            IF(lwp) WRITE(numout,*) '           using a fixed diffusive velocity = ', rn_Ud,' m/s   and   Ld = Max(e1,e2)'
-            IF(lwp) WRITE(numout,*) '           maximum reachable coefficient (at the Equator) = ', zah_max, cl_Units, '  for e1=1°)'
+            IF(lwp) THEN
+               WRITE(numout,*) '   ==>>>   eddy diffusivity = F( e1, e2 ) or F( e1^3, e2^3 ) (lap or blp case)'
+               WRITE(numout,*) '           using a fixed diffusive velocity = ', rn_Ud,' m/s   and   Ld = Max(e1,e2)'
+               WRITE(numout,*) '           maximum reachable coefficient (at the Equator) = ', zah_max, cl_Units, '  for e1=1°)'
+               IF(lflush) CALL FLUSH(numout)
+            ENDIF
             CALL ldf_c2d( 'TRA', zUfac      , inn        , ahtu, ahtv )    ! value proportional to scale factor^inn
             !
          CASE(  21  )      !==  time varying 2D field  ==!
-            IF(lwp) WRITE(numout,*) '   ==>>>   eddy diffusivity = F( latitude, longitude, time )'
-            IF(lwp) WRITE(numout,*) '                            = F( growth rate of baroclinic instability )'
-            IF(lwp) WRITE(numout,*) '            min value = 0.2 * aht0 (with aht0= 1/2 rn_Ud*rn_Ld)'
-            IF(lwp) WRITE(numout,*) '            max value =       aei0 (with aei0=1/2 rn_Ue*Le  increased to aht0 within 20N-20S'
+            IF(lwp) THEN
+               WRITE(numout,*) '   ==>>>   eddy diffusivity = F( latitude, longitude, time )'
+               WRITE(numout,*) '                            = F( growth rate of baroclinic instability )'
+               WRITE(numout,*) '            min value = 0.2 * aht0 (with aht0= 1/2 rn_Ud*rn_Ld)'
+               WRITE(numout,*) '            max value =       aei0 (with aei0=1/2 rn_Ue*Le  increased to aht0 within 20N-20S'
+               IF(lflush) CALL FLUSH(numout)
+            ENDIF
             !
             l_ldftra_time = .TRUE.     ! will be calculated by call to ldf_tra routine in step.F90
@@ -344,5 +365,8 @@
             !
          CASE( -30  )      !== fixed 3D shape read in file  ==!
-            IF(lwp) WRITE(numout,*) '   ==>>>   eddy diffusivity = F(i,j,k) read in eddy_diffusivity.nc file'
+            IF(lwp) THEN
+               WRITE(numout,*) '   ==>>>   eddy diffusivity = F(i,j,k) read in eddy_diffusivity.nc file'
+               IF(lflush) CALL FLUSH(numout)
+            ENDIF
             CALL iom_open( 'eddy_diffusivity_3D.nc', inum )
             CALL iom_get ( inum, jpdom_data, 'ahtu_3D', ahtu )
@@ -351,13 +375,19 @@
             !
          CASE(  30  )      !==  fixed 3D shape  ==!
-            IF(lwp) WRITE(numout,*) '   ==>>>   eddy diffusivity = F( latitude, longitude, depth )'
-            IF(lwp) WRITE(numout,*) '           using a fixed diffusive velocity = ', rn_Ud,' m/s   and   Ld = Max(e1,e2)'
-            IF(lwp) WRITE(numout,*) '           maximum reachable coefficient (at the Equator) = ', zah_max, cl_Units, '  for e1=1°)'
+            IF(lwp) THEN
+               WRITE(numout,*) '   ==>>>   eddy diffusivity = F( latitude, longitude, depth )'
+               WRITE(numout,*) '           using a fixed diffusive velocity = ', rn_Ud,' m/s   and   Ld = Max(e1,e2)'
+               WRITE(numout,*) '           maximum reachable coefficient (at the Equator) = ', zah_max, cl_Units, '  for e1=1°)'
+               IF(lflush) CALL FLUSH(numout)
+            ENDIF
             CALL ldf_c2d( 'TRA', zUfac      , inn        , ahtu, ahtv )    ! surface value proportional to scale factor^inn
             CALL ldf_c1d( 'TRA', ahtu(:,:,1), ahtv(:,:,1), ahtu, ahtv )    ! reduction with depth
             !
          CASE(  31  )      !==  time varying 3D field  ==!
-            IF(lwp) WRITE(numout,*) '   ==>>>   eddy diffusivity = F( latitude, longitude, depth , time )'
-            IF(lwp) WRITE(numout,*) '           proportional to the velocity : 1/2 |u|e or 1/12 |u|e^3'
+            IF(lwp) THEN
+               WRITE(numout,*) '   ==>>>   eddy diffusivity = F( latitude, longitude, depth , time )'
+               WRITE(numout,*) '           proportional to the velocity : 1/2 |u|e or 1/12 |u|e^3'
+               IF(lflush) CALL FLUSH(numout)
+            ENDIF
             !
             l_ldftra_time = .TRUE.     ! will be calculated by call to ldf_tra routine in step.F90
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/OBS/obs_write.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/OBS/obs_write.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/OBS/obs_write.F90	(revision 10986)
@@ -186,4 +186,5 @@
          WRITE(numout,*)'~~~~~~~~~~~~~'
          WRITE(numout,*)'Writing '//TRIM(clfiletype)//' feedback file : ',TRIM(clfname)
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
 
@@ -458,4 +459,5 @@
          WRITE(numout,*)'~~~~~~~~~~~~~'
          WRITE(numout,*)'Writing '//TRIM(surfdata%cvars(1))//' feedback file : ',TRIM(clfname)
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
 
@@ -571,4 +573,5 @@
          WRITE(numout,*) 'obs_wri_stats :'
          WRITE(numout,*) '~~~~~~~~~~~~~~~'
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
 
@@ -600,4 +603,5 @@
             WRITE(numout,*) 'Overall RMS obs minus model of the good observations: ',sqrt( zsumx2/inumgoodobsmpp )
             WRITE(numout,*) ''
+            IF(lflush) CALL FLUSH(numout)
          ENDIF
 
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/OBS/obsinter_h2d.h90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/OBS/obsinter_h2d.h90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/OBS/obsinter_h2d.h90	(revision 10986)
@@ -281,4 +281,5 @@
                   WRITE(numout,*)'Switching to great circle distance'
                   WRITE(numout,*)
+                  IF(lflush) CALL FLUSH(numout)
                ENDIF
                CALL obs_int_h2d_ds1( kpk2, ikmax,                        &
@@ -1129,4 +1130,5 @@
             WRITE(numout,*)' Iterations for i,j exceed max iteration count!'
             WRITE(numout,*)
+            IF(lflush) CALL FLUSH(numout)
             
             ldfail = .TRUE.
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/SBC/cpl_oasis3.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/SBC/cpl_oasis3.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/SBC/cpl_oasis3.F90	(revision 10986)
@@ -157,8 +157,11 @@
          IF( njmpp + jpj - 1 == jpjglo ) nlej = jpj
       ENDIF 
-      IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) 'cpl_define : initialization in coupled ocean/atmosphere case'
-      IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~~~~~~'
-      IF(lwp) WRITE(numout,*)
+      IF(lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'cpl_define : initialization in coupled ocean/atmosphere case'
+         WRITE(numout,*) '~~~~~~~~~~~~~~~~~'
+         WRITE(numout,*)
+         IF(lflush) CALL FLUSH(numout)
+      ENDIF
 
       ncplmodel = kcplmodel
@@ -208,4 +211,5 @@
          WRITE(numout,*) ' multiexchg: nldi, nlei, nimpp =', nldi, nlei, nimpp
          WRITE(numout,*) ' multiexchg: nldj, nlej, njmpp =', nldj, nlej, njmpp
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
    
@@ -243,5 +247,8 @@
                   END IF
 #endif
-                  IF( ln_ctl ) WRITE(numout,*) "Define", ji, jc, jm, " "//TRIM(zclname), " for ", OASIS_Out
+                  IF( ln_ctl ) THEN 
+                     WRITE(numout,*) "Define", ji, jc, jm, " "//TRIM(zclname), " for ", OASIS_Out
+                     IF(lflush) CALL FLUSH(numout)
+                  ENDIF
                   CALL oasis_def_var (ssnd(ji)%nid(jc,jm), zclname, id_part   , (/ 2, 1 /),   &
                      &                OASIS_Out          , ishape , OASIS_REAL, nerror )
@@ -288,5 +295,8 @@
                   END IF
 #endif
-                  IF( ln_ctl ) WRITE(numout,*) "Define", ji, jc, jm, " "//TRIM(zclname), " for ", OASIS_In
+                  IF( ln_ctl ) THEN
+                     WRITE(numout,*) "Define", ji, jc, jm, " "//TRIM(zclname), " for ", OASIS_In
+                     IF(lflush) CALL FLUSH(numout)
+                  ENDIF
                   CALL oasis_def_var (srcv(ji)%nid(jc,jm), zclname, id_part   , (/ 2, 1 /),   &
                      &                OASIS_In           , ishape , OASIS_REAL, nerror )
@@ -361,4 +371,5 @@
                      WRITE(numout,*) '     -     Sum value is ', SUM(pdata(:,:,jc))
                      WRITE(numout,*) '****************'
+                     IF(lflush) CALL FLUSH(numout)
                   ENDIF
                ENDIF
@@ -420,5 +431,8 @@
                   &        kinfo == OASIS_RecvOut .OR. kinfo == OASIS_FromRestOut
                
-               IF ( ln_ctl )   WRITE(numout,*) "llaction, kinfo, kstep, ivarid: " , llaction, kinfo, kstep, srcv(kid)%nid(jc,jm)
+               IF ( ln_ctl )   THEN
+                  WRITE(numout,*) "llaction, kinfo, kstep, ivarid: " , llaction, kinfo, kstep, srcv(kid)%nid(jc,jm)
+                  IF(lflush) CALL FLUSH(numout)
+               ENDIF
                
                IF ( llaction ) THEN
@@ -442,4 +456,5 @@
                      WRITE(numout,*) '     -     Sum value is ', SUM(pdata(:,:,jc))
                      WRITE(numout,*) '****************'
+                     IF(lflush) CALL FLUSH(numout)
                   ENDIF
                   
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/SBC/fldread.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/SBC/fldread.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/SBC/fldread.F90	(revision 10986)
@@ -304,4 +304,5 @@
                      & sd(jf)%nrec_b(1), sd(jf)%nrec_a(1), REAL(sd(jf)%nrec_b(2),wp)/rday, REAL(sd(jf)%nrec_a(2),wp)/rday
                   WRITE(numout, *) '      it_offset is : ',it_offset
+                  IF(lflush) CALL FLUSH(numout)
                ENDIF
                ! temporal interpolation weights
@@ -315,4 +316,5 @@
                   WRITE(numout, clfmt) TRIM(sd(jf)%clvar), kt, REAL(isecsbc,wp)/rday, nyear, nmonth, nday,    &
                      &                 sd(jf)%nrec_a(1), REAL(sd(jf)%nrec_b(2),wp)/rday, REAL(sd(jf)%nrec_a(2),wp)/rday
+                  IF(lflush) CALL FLUSH(numout)
                ENDIF
             ENDIF
@@ -440,5 +442,8 @@
          !
          clfmt = "('   fld_init : time-interpolation for ', a, ' read previous record = ', i6, ' at time = ', f7.2, ' days')"
-         IF(lwp .AND. nprint > 1) WRITE(numout, clfmt) TRIM(sdjf%clvar), sdjf%nrec_a(1), REAL(sdjf%nrec_a(2),wp)/rday
+         IF(lwp .AND. nprint > 1) THEN
+            WRITE(numout, clfmt) TRIM(sdjf%clvar), sdjf%nrec_a(1), REAL(sdjf%nrec_a(2),wp)/rday
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
          !
       ENDIF
@@ -762,6 +767,9 @@
       ENDIF
 
-      IF(lwp.AND. nprint > 1) WRITE(numout,*) 'Dim size for ',        TRIM(clvar),' is ', ilendta
-      IF(lwp.AND. nprint > 1) WRITE(numout,*) 'Number of levels for ',TRIM(clvar),' is ', ipk
+      IF(lwp.AND. nprint > 1) THEN
+         WRITE(numout,*) 'Dim size for ',        TRIM(clvar),' is ', ilendta
+         WRITE(numout,*) 'Number of levels for ',TRIM(clvar),' is ', ipk
+         IF(lflush) CALL FLUSH(numout)
+      ENDIF
       !
       SELECT CASE( ipk )
@@ -1174,6 +1182,9 @@
                      END DO
                      sd(ju)%rotn(jn) = .TRUE.               ! vector was rotated 
-                     IF( lwp .AND. kt == nit000 .AND. nprint > 1)   WRITE(numout,*)   &
+                     IF( lwp .AND. kt == nit000 .AND. nprint > 1)   THEN
+                         WRITE(numout,*)   &
                         &   'fld_read: vector pair ('//TRIM(sd(ju)%clvar)//', '//TRIM(sd(iv)%clvar)//') rotated on to model grid'
+                         IF(lflush) CALL FLUSH(numout)
+                     ENDIF
                   ENDIF
                ENDIF
@@ -1340,4 +1351,5 @@
             call flush(numout)
          END DO
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
@@ -1411,4 +1423,5 @@
          ENDIF
          IF( ASSOCIATED(ref_wgts(kw)%data_wgt) )  WRITE(numout,*) '       allocated'
+         IF(lflush) CALL FLUSH(numout)
       END DO
       !
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/SBC/geo2ocean.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/SBC/geo2ocean.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/SBC/geo2ocean.F90	(revision 10986)
@@ -69,7 +69,10 @@
       !
       IF( lmust_init ) THEN      ! at 1st call only: set  gsin. & gcos.
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) ' rot_rep: coordinate transformation : geographic <==> model (i,j)-components'
-         IF(lwp) WRITE(numout,*) ' ~~~~~~~~    '
+         IF(lwp) THEN
+            WRITE(numout,*)
+            WRITE(numout,*) ' rot_rep: coordinate transformation : geographic <==> model (i,j)-components'
+            WRITE(numout,*) ' ~~~~~~~~    '
+            IF(lflush) CALL FLUSH(numout)
+      ENDIF
          !
          CALL angle( glamt, gphit, glamu, gphiu, glamv, gphiv, glamf, gphif )       ! initialization of the transformation
@@ -450,7 +453,10 @@
       ! -----------------------------------------------
       IF( lmust_init ) THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) ' obs_rot : geographic <--> stretched'
-         IF(lwp) WRITE(numout,*) ' ~~~~~~~   coordinate transformation'
+         IF(lwp) THEN
+            WRITE(numout,*)
+            WRITE(numout,*) ' obs_rot : geographic <--> stretched'
+            WRITE(numout,*) ' ~~~~~~~   coordinate transformation'
+            IF(lflush) CALL FLUSH(numout)
+      ENDIF
          CALL angle( glamt, gphit, glamu, gphiu, glamv, gphiv, glamf, gphif )       ! initialization of the transformation
          lmust_init = .FALSE.
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/SBC/sbcapr.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/SBC/sbcapr.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/SBC/sbcapr.F90	(revision 10986)
@@ -91,4 +91,5 @@
          WRITE(numout,*) '   Namelist namsbc_apr : Atmospheric PRessure as extrenal forcing'
          WRITE(numout,*) '      ref. pressure: global mean Patm (T) or a constant (F)  ln_ref_apr = ', ln_ref_apr
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
@@ -99,10 +100,12 @@
          IF(lwp) WRITE(numout,*) '         Reference Patm used : ', rn_pref, ' N/m2'
       ENDIF
+      IF(lwp .AND. lflush) CALL FLUSH(numout)
       !
       r1_grau = 1.e0 / (grav * rau0)               !* constant for optimization
       !
       !                                            !* control check
-      IF ( ln_apr_obc  ) THEN
-         IF(lwp) WRITE(numout,*) '         Inverse barometer added to OBC ssh data'
+      IF ( ln_apr_obc  .AND. lwp) THEN
+         WRITE(numout,*) '         Inverse barometer added to OBC ssh data'
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
 !jc: stop below should rather be a warning 
@@ -155,9 +158,15 @@
          !                                            !* Restart: read in restart file
          IF( ln_rstart .AND. iom_varid( numror, 'ssh_ibb', ldstop = .FALSE. ) > 0 ) THEN 
-            IF(lwp) WRITE(numout,*) 'sbc_apr:   ssh_ibb read in the restart file'
+            IF(lwp .AND. nprint > 0) THEN
+               WRITE(numout,*) 'sbc_apr:   ssh_ibb read in the restart file'
+               IF(lflush) CALL FLUSH(numout)
+            ENDIF
             CALL iom_get( numror, jpdom_autoglo, 'ssh_ibb', ssh_ibb, ldxios = lrxios )   ! before inv. barometer ssh
             !
          ELSE                                         !* no restart: set from nit000 values
-            IF(lwp) WRITE(numout,*) 'sbc_apr:   ssh_ibb set to nit000 values'
+            IF(lwp .AND. nprint > 0) THEN
+               WRITE(numout,*) 'sbc_apr:   ssh_ibb set to nit000 values'
+               IF(lflush) CALL FLUSH(numout)
+            ENDIF
             ssh_ibb(:,:) = ssh_ib(:,:)
          ENDIF
@@ -166,7 +175,10 @@
       IF( lrst_oce ) THEN                       !      Write in the ocean restart file     !
          !                                      ! ---------------------------------------- !
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'sbc_apr : ssh_ib written in ocean restart file at it= ', kt,' date= ', ndastp
-         IF(lwp) WRITE(numout,*) '~~~~'
+         IF(lwp .AND. nprint > 0) THEN
+            WRITE(numout,*)
+            WRITE(numout,*) 'sbc_apr : ssh_ib written in ocean restart file at it= ', kt,' date= ', ndastp
+            WRITE(numout,*) '~~~~'
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
          IF( lwxios ) CALL iom_swap(      cwxios_context          )
          CALL iom_rstput( kt, nitrst, numrow, 'ssh_ibb' , ssh_ib, ldxios = lwxios )
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/SBC/sbcblk.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/SBC/sbcblk.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/SBC/sbcblk.F90	(revision 10986)
@@ -278,4 +278,5 @@
          CASE( np_ECMWF     )   ;   WRITE(numout,*) '   ==>>>   "ECMWF" algorithm       (IFS cycle 31)'
          END SELECT
+         IF(lflush) CALL FLUSH(numout)
          !
       ENDIF
